const int pins[8] = { 9,10,11,12,13,A0,A1,A2};
const int posPins[4] = { 5,6,7,8 };
const int chisla[10][8] = { { 1,1,1,1,1,1,0,0 },{ 0,1,1,0,0,0,0,0 },{ 1,1,0,1,1,0,1,0 },{ 1,1,1,1,0,0,1,0 },{ 0,1,1,0,0,1,1,0 },{ 1,0,1,1,0,1,1,0 },{ 1,0,1,1,1,1,1,0 },{ 1,1,1,0,0,0,0,0 },{ 1,1,1,1,1,1,1,0 },{ 1,1,1,1,0,1,1,0 } };
const int E[8] = {1,0,0,1,1,1,1,0};
const int r[8] = {0,0,0,0,1,0,1,0};
int cursor = 0;
//////////
const int period = 60; // Time of accurate meassurement in seconds
/////////
double temp;
int Temp;
int cifri[4];
unsigned long impuls = 0;
float fon = 0;
long mkr = 0;
int point = 3;
bool trigger = false;
unsigned long times;
bool Err = false;
bool beep = true;
  bool block = false;
   long stime;
void setup()
{
	pinMode(A3, INPUT);
	pinMode(3, OUTPUT);
	for (int a = 0;a < 8;a++)
	{
		pinMode(pins[a], OUTPUT);
	}
	for (int b = 0;b < 4; b++)
	{
		pinMode(posPins[b], OUTPUT);
	}

	attachInterrupt(0, clk, FALLING);
	times = millis();
	while ((millis() - times) < 60000)
	{
		Err = true;
		emptyScr();
		
		if ((impuls > 1))
		{
			Err = false;
      tone(3, 1000,100);
			clrScr();
			break;
		}
	}
	if (Err)
	{
		while (true)
		{
			showErr(1);
			tone(3, 500);
		}
	}
}

void loop()
{
	beep = true;
	bool state = button();
	if (trigger)
	{
		
		times = millis();
		while (millis() - times < 36000)
		{
    state = button();
			if ((impuls > 19 + (impuls / 1000 )* 20) && (millis() - times > 0))
			{
				fon = ((float)18000/(millis() - times))*impuls*2;
				break;
			}
			else
			{
				fon = impuls;
			}
			if (state)
			{
				fon = 0;
				mkr = 0;
				
				break;
			}
			showInt(mkr, point);
		}
		if (state)
		{  tone(3, 1000,100);
			times = millis();
			impuls = 0;
			while (millis()-times<period*1000)
			{
				fon = impuls;
				showInt(60-((millis() - times) / 1000), 0);
			}
			mkr = round(fon*((float)36/period));
			reCalc();
			impuls = 0;
			trigger = false;
			while (true)
			{
				showInt(mkr, point);
				beep = false;
         if(millis()-stime > 1000)
         {
			 
        tone(3, 1000,500);
        stime = millis();
         }
				if (button())
				{
					
        tone(3, 1000,100);
        fon = mkr;
        impuls = 0;
					break;
				}
			}
		}
		mkr = round(fon);
		reCalc();
		impuls = 0;
		trigger = false;
	}
	showInt(mkr, point);
}

void showErr(int number)
{
	
	for (int i = 0;i < 4;i++)
	{
		clrScr();
		digitalWrite(posPins[i], LOW);
		if (i == 0)
		{
			for (int f = 0; f < 8;f++)
			{
				digitalWrite(pins[f], E[f]);
			}
		}
		if (i == 1)
		{
			for (int f = 0; f < 8;f++)
			{
				digitalWrite(pins[f], r[f]);
			}
		}
		if (i == 2)
		{
			for (int f = 0; f < 8;f++)
			{
				digitalWrite(pins[f], r[f]);
			}
		}
		if (i == 3)
		{
			for (int f = 0; f < 8;f++)
			{
				digitalWrite(pins[f], chisla[number][f]);
			}
		}
	}
}
void showInt(int input,int DP)
{
	temp = input;
	Temp = round(temp);
	cifri[0] = Temp / 1000;
	cifri[1] = Temp % 1000 / 100;
	cifri[2] = Temp % 1000 % 100 / 10;
	cifri[3] = Temp % 10;
	
	for (cursor = 0;cursor < 4; cursor++)
	{
		clrScr();
		for (int i = 0; i < 8; i++)
		{
			
			digitalWrite(posPins[cursor], LOW);
			bool enable = true;
			int Epos = 0;
				for (int j = 0;j < 4;j++)
				{
					if ((cifri[j] == 0)&&cursor!=3)
					{
						enable = false;
					}
					else
					{
						Epos = j;
						enable = true;
						break;
					}
				}
			
			if(enable&&(cursor>=Epos))
				digitalWrite(pins[i], chisla[cifri[cursor]][i]);
			if (cursor == DP)
			{
				digitalWrite(pins[7], HIGH);
			}
			else
			{
				digitalWrite(pins[7], LOW);
			}
		}
		
	}
}
void emptyScr()
{
	for (cursor = 0; cursor < 4;cursor++)
	{
		digitalWrite(posPins[cursor], LOW);
		digitalWrite(pins[6], HIGH);
			
	}
}
void clrScr()
{
	for (int a = 0; a < 4;a++)
	{
		for (int i = 0; i < 8; i++)
		{
			digitalWrite(pins[i], LOW);
			digitalWrite(posPins[a], HIGH);
		}
	}
}
void clk()
{
	trigger = true;
	if (beep)
	{
		tone(3, 500, 20);
	}
	impuls++;
}
bool button()
{
	
	if ((digitalRead(A3) == HIGH)&&(!block))
	{
		block = true;
		
		return(true);	
	}
	else if (digitalRead(A3) == LOW &&(block))
	{
		block = false;
		return(false);
	}
	else
	{
 
		return(false);
	}
}
void reCalc()
{
	if ((mkr > 9999) && (mkr <= 9999000))
	{
		mkr = mkr / 1000;
		point = 2;
	}
	else if (mkr > 9999000)
	{
		mkr = mkr / 1000000;
		point = 1;
	}
	else
	{
		point = 3;
	}
}

